<!--
 Copyright (c) 2023 by frostime (Yp Z), All Rights Reserved. 
 Author       : Yp Z
 Date         : 2023-07-02 00:30:29
 FilePath     : /src/lib/Settings/panel.svelte
 LastEditTime : 2023-07-08 14:43:32
 Description  : 
-->
<script lang="ts">
    import { createEventDispatcher } from 'svelte';
    import type { ISettingItem } from '$lib/types';
    import SettingItem from './item.svelte';

    const dispatch = createEventDispatcher();

    export let dataname: string;
    //通过列表来传入的设置项, 可以为空
    export let settingItems: ISettingItem[] = [];
    export let display: boolean = true;

    $: fn__none = display ? '' : 'fn__none';

    function changed(e: CustomEvent) {
        dispatch('changed', e.detail);
    }
</script>

<div class="config__tab-container {fn__none}" data-name={dataname}>
    <!-- 1. 可以通过传入 settingItems 来自动构建 GUI -->
    {#each settingItems as item (item.settingValue)}
        <SettingItem
            type={item.type}
            title={item.title}
            hint={item.hint}
            settingKey={item.settingKey}
            settingValue={item.settingValue}
            placeholder={item?.placeholder}
            slider={item?.slider}
            options={item?.options}
            on:changed={changed}
        />
    {/each}
    <!-- 2. 也可以使用 slot -->
    <slot />
</div>
